HDU 1677:Nested Dolls


Nested Dolls

Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3817    Accepted Submission(s): 1166


Problem Description
Dilworth is the world’s most prominent collector of Russian nested dolls: he literally has thousands of them! You know, the wooden hollow dolls of different sizes of which the smallest doll is contained in the second smallest, and this doll is in turn contained in the next one and so forth. One day he wonders if there is another way of nesting them so he will end up with fewer nested dolls? After all, that would make his collection even more magnificent! He unpacks each nested doll and measures the width and height of each contained doll. A doll with width w1 and height h1 will fit in another doll of width w2 and height h2 if and only if w1 < w2 and h1 < h2. Can you help him calculate the smallest number of nested dolls possible to assemble from his massive list of measurements?
 

Input
On the first line of input is a single positive integer 1 <= t <= 20 specifying the number of test cases to follow. Each test case begins with a positive integer 1 <= m <= 20000 on a line of itself telling the number of dolls in the test case. Next follow 2m positive integers w1, h1,w2, h2, . . . ,wm, hm, where wi is the width and hi is the height of doll number i. 1 <= wi, hi <= 10000 for all i.
 

Output
For each test case there should be one line of output containing the minimum number of nested dolls possible.
 

Sample Input
  
  
4 3 20 30 40 50 30 40 4 20 30 10 10 30 20 40 50 3 10 30 20 20 30 10 4 10 10 20 30 40 50 39 51
 

Sample Output
  
  
1 2 3 2


题目意思:

俄罗斯套娃,给出N个娃娃的宽度和高度,一个娃娃能套到另一个娃娃的条件是,这个娃娃的宽度小于另一个娃娃的宽度并且这个娃娃的高度小于另一个娃娃的高度,才

能套进去。能嵌套的娃娃要尽可能套。答案要的是最后最少的娃娃数量(小的娃娃已经套在大的里面了)。

解题思路:

单纯的贪心去处理,采用普通的计数方式,会超时,例如找到第一个没有套的娃娃,只要当前娃娃比之前套的娃娃大,就嵌套,并记录第一个套不下的娃娃。

然后再进行相同的操作来套娃(这就是我最原先的想法)。这样做会超时。

可以采取贪心加二分查找解决这个题目。

首先按照娃娃的宽度从大到小排序。宽度相同的时候,按照娃娃的高度从小到大排序。

这样的话,我们知道后面的娃娃才有可能套到前面的娃娃,然后看高度。

开辟一个数组来放娃娃的高度。

取一个娃娃,在数组中查询到第一个大于该娃娃高度的娃娃,如果发现它的下标是len,说明当前娃娃不可以套到之前的任何一个娃娃中,则len++。在由当前这些娃娃

去套别的娃娃。如果发现下标小于len,说明之前有娃娃可以套住这个娃娃,更新那个位置上的值,它就是那一组套娃中最小的套娃。


#include<iostream>
#include<stdio.h>
#include<string.h>
#include<algorithm>

using namespace std;

const int MAXN = 20010;
int a[MAXN];
struct doll
{
    int width;
    int height;
}d[MAXN];
bool cmp(struct doll d1,struct doll d2)
{
    if(d1.width==d2.width)
        return d1.height<d2.height;  ///从小到大
    else
        return d1.width>d2.width;  ///从大到小
}
int Binary_Search(int len,int num)
{
    int low,high,mid;
    low = 0;
    high = len;
    while(low<high)
    {
        mid = (low+high)/2;
        if(a[mid] <= num)
            low = mid+1;
        else
            high = mid;
    }
    return low;
}
int main()
{
    int T,N;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d",&N);
        for(int i = 0; i < N; i++)
            scanf("%d%d",&d[i].width,&d[i].height);
        sort(d,d+N,cmp);
        int len = 0;
        memset(a,0,sizeof(a));
        for(int i = 0; i < N; i++)
        {
            int pos = Binary_Search(len,d[i].height);
            a[pos] = d[i].height;
            if(pos==len)
                len++;
        }
        printf("%d\n",len);
    }
    return 0;
}


  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值